#define SCPLX
#include "atlas_misc.h"
void ATL_cupKBmm16_16_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupKBmm32_16_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupKBmm48_16_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupKBmm64_16_1_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cpKBmm_b0
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupKBmm16_16_1_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupKBmm32_16_1_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupKBmm48_16_1_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupKBmm64_16_1_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cpKBmm_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupKBmm16_16_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupKBmm32_16_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupKBmm48_16_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cupKBmm64_16_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cpKBmm_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_cgpKBmm
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);

static void ATL_CupKBmm16_16_1_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc)
{
   const float *rA = A + lda*M, *rB = B + ldb*N;
   ATL_cupKBmm16_16_1_bX(M, N, K, alpha, A, lda, B, ldb, ATL_rnone, C, ldc); 
   ATL_cupKBmm16_16_1_b1(M, N, K, alpha, A, lda, rB, ldb, beta, C+1, ldc); 
   ATL_cupKBmm16_16_1_bX(M, N, K, alpha, rA, lda, rB, ldb, ATL_rnone, C, ldc); 
   ATL_cupKBmm16_16_1_b1(M, N, K, alpha, rA, lda, B, ldb, ATL_rone, C+1, ldc); 
}
static void ATL_CupKBmm32_16_1_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc)
{
   const float *rA = A + lda*M, *rB = B + ldb*N;
   ATL_cupKBmm32_16_1_bX(M, N, K, alpha, A, lda, B, ldb, ATL_rnone, C, ldc); 
   ATL_cupKBmm32_16_1_b1(M, N, K, alpha, A, lda, rB, ldb, beta, C+1, ldc); 
   ATL_cupKBmm32_16_1_bX(M, N, K, alpha, rA, lda, rB, ldb, ATL_rnone, C, ldc); 
   ATL_cupKBmm32_16_1_b1(M, N, K, alpha, rA, lda, B, ldb, ATL_rone, C+1, ldc); 
}
static void ATL_CupKBmm48_16_1_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc)
{
   const float *rA = A + lda*M, *rB = B + ldb*N;
   ATL_cupKBmm48_16_1_bX(M, N, K, alpha, A, lda, B, ldb, ATL_rnone, C, ldc); 
   ATL_cupKBmm48_16_1_b1(M, N, K, alpha, A, lda, rB, ldb, beta, C+1, ldc); 
   ATL_cupKBmm48_16_1_bX(M, N, K, alpha, rA, lda, rB, ldb, ATL_rnone, C, ldc); 
   ATL_cupKBmm48_16_1_b1(M, N, K, alpha, rA, lda, B, ldb, ATL_rone, C+1, ldc); 
}
static void ATL_CupKBmm64_16_1_b1
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc)
{
   const float *rA = A + lda*M, *rB = B + ldb*N;
   ATL_cupKBmm64_16_1_bX(M, N, K, alpha, A, lda, B, ldb, ATL_rnone, C, ldc); 
   ATL_cupKBmm64_16_1_b1(M, N, K, alpha, A, lda, rB, ldb, beta, C+1, ldc); 
   ATL_cupKBmm64_16_1_bX(M, N, K, alpha, rA, lda, rB, ldb, ATL_rnone, C, ldc); 
   ATL_cupKBmm64_16_1_b1(M, N, K, alpha, rA, lda, B, ldb, ATL_rone, C+1, ldc); 
}
#include "cmm.h"

typedef void (*MMfunc)(const int, const int, const int, const TYPE,
                       const TYPE *, const int, const TYPE *, const int,
                       const TYPE, TYPE *, const int);

void ATL_cpKBmm_b1
   (const int M, const int N, const int K, const TYPE alpha,
    const TYPE *A, const int lda, const TYPE *B, const int ldb,
    const TYPE beta, TYPE *C, const int ldc)
{

   static MMfunc mmfunc[80] = 
   {
      NULL,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_CupKBmm16_16_1_b1,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_CupKBmm32_16_1_b1,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_CupKBmm48_16_1_b1,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_CupKBmm64_16_1_b1,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm,
      ATL_cgpKBmm
   };

   mmfunc[K](M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
}
void ATL_cpKBmm_b0
   (const int M, const int N, const int K, const TYPE alpha,
    const TYPE *A, const int lda, const TYPE *B, const int ldb,
    const TYPE beta, TYPE *C, const int ldc);
void ATL_cpKBmm_bX
   (const int M, const int N, const int K, const TYPE alpha,
    const TYPE *A, const int lda, const TYPE *B, const int ldb,
    const TYPE beta, TYPE *C, const int ldc);

void ATL_cpKBmm
   (const int M, const int N, const int K, const TYPE alpha,
    const TYPE *A, const int lda, const TYPE *B, const int ldb,
    const TYPE beta, TYPE *C, const int ldc)
{
   if (M != NB || N != NB)
      ATL_cgpKBmm(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
   else if (beta == ATL_rone)
      ATL_cpKBmm_b1(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
   else if (beta == ATL_rzero)
      ATL_cpKBmm_b0(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
   else
      ATL_cpKBmm_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
}
