#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_sJIK80x80x80TN0x0x0_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=80, NB=80, KB=80, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=4, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const float *stM = A + (((lda) << 6)+((lda) << 4));
   const float *stN = B + (((ldb) << 6)+((ldb) << 4));
   const float *pfA = A + M;
   #define incAk 1
   const int incAm = ((((lda) << 2)) - 80), incAn = -(((lda) << 6)+((lda) << 4));
   #define incBk 1
   const int incBm = -80, incBn = (((ldb) << 2));
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (((ldc) << 2)) - 80;
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const float *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda);
   const float *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb);
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0, rB1, rB2, rB3;
   register float m0, m1, m2, m3;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2, rC0_3, rC1_3, rC2_3, rC3_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+48);
      ATL_pfl1R(pfA+64);
      pfA += lda;
      do /* M-loop */
      {
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         rC0_2 = *pC2;
         rC0_3 = *pC3;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         rA2 = *pA2;
         rA3 = *pA3;
         rB1 = *pB1;
         rB2 = *pB2;
         m0 = rA0 * rB0;
         rB3 = *pB3;
         m1 = rA1 * rB0;
         m2 = rA2 * rB0;
         m3 = rA3 * rB0;

/*
 *       Peel first 1 iterations for C assignment
 */
         rC0_0 = m0;
         m0 = rA0 * rB1;
         rC1_0 = m1;
         m1 = rA1 * rB1;
         rC2_0 = m2;
         m2 = rA2 * rB1;
         rC3_0 = m3;
         m3 = rA3 * rB1;
         rC0_1 = m0;
         m0 = rA0 * rB2;
         rC1_1 = m1;
         m1 = rA1 * rB2;
         rC2_1 = m2;
         m2 = rA2 * rB2;
         rC3_1 = m3;
         m3 = rA3 * rB2;
         rC0_2 = m0;
         m0 = rA0 * rB3;
         rC1_2 = m1;
         m1 = rA1 * rB3;
         rC2_2 = m2;
         m2 = rA2 * rB3;
         rC3_2 = m3;
         m3 = rA3 * rB3;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA1[1];
         rA2 = pA2[1];
         rA3 = pA3[1];
         rB1 = pB1[1];
         rB2 = pB2[1];
         rB3 = pB3[1];
         rC0_3 = m0;
         m0 = rA0 * rB0;
         rC1_3 = m1;
         m1 = rA1 * rB0;
         rC2_3 = m2;
         m2 = rA2 * rB0;
         rC3_3 = m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         pA1 += incAk;
         pA2 += incAk;
         pA3 += incAk;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=0; k < 78; k++) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB1;
            rC1_0 += m1;
            m1 = rA1 * rB1;
            rC2_0 += m2;
            m2 = rA2 * rB1;
            rC3_0 += m3;
            m3 = rA3 * rB1;
            rC0_1 += m0;
            m0 = rA0 * rB2;
            rC1_1 += m1;
            m1 = rA1 * rB2;
            rC2_1 += m2;
            m2 = rA2 * rB2;
            rC3_1 += m3;
            m3 = rA3 * rB2;
            rC0_2 += m0;
            m0 = rA0 * rB3;
            rC1_2 += m1;
            m1 = rA1 * rB3;
            rC2_2 += m2;
            m2 = rA2 * rB3;
            rC3_2 += m3;
            m3 = rA3 * rB3;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA1[1];
            rA2 = pA2[1];
            rA3 = pA3[1];
            rB1 = pB1[1];
            rB2 = pB2[1];
            rB3 = pB3[1];
            rC0_3 += m0;
            m0 = rA0 * rB0;
            rC1_3 += m1;
            m1 = rA1 * rB0;
            rC2_3 += m2;
            m2 = rA2 * rB0;
            rC3_3 += m3;
            m3 = rA3 * rB0;
            pA0 += incAk;
            pA1 += incAk;
            pA2 += incAk;
            pA3 += incAk;
            pB0 += incBk;
            pB1 += incBk;
            pB2 += incBk;
            pB3 += incBk;
         } /* end K-loop */
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC1_0 += m1;
         m1 = rA1 * rB1;
         rC2_0 += m2;
         m2 = rA2 * rB1;
         rC3_0 += m3;
         m3 = rA3 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC1_1 += m1;
         m1 = rA1 * rB2;
         rC2_1 += m2;
         m2 = rA2 * rB2;
         rC3_1 += m3;
         m3 = rA3 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rC1_2 += m1;
         m1 = rA1 * rB3;
         rC2_2 += m2;
         m2 = rA2 * rB3;
         rC3_2 += m3;
         m3 = rA3 * rB3;
         rC0_3 += m0;
         rC1_3 += m1;
         rC2_3 += m2;
         rC3_3 += m3;
         pA0 += incAk0;
         pA1 += incAk0;
         pA2 += incAk0;
         pA3 += incAk0;
         pB0 += incBk0;
         pB1 += incBk0;
         pB2 += incBk0;
         pB3 += incBk0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         pC1[3] = rC3_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         pC2[2] = rC2_2;
         pC2[3] = rC3_2;
         *pC3 = rC0_3;
         pC3[1] = rC1_3;
         pC3[2] = rC2_3;
         pC3[3] = rC3_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pA2 += incAm;
         pA3 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
