#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
void ATL_zJIK32x32x32NN0x0x0_aX_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=32, NB=32, KB=32, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=4, ku=1, pf=0
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const double *stM = A + 64;
   const double *stN = B + (((ldb) << 6));
   const double BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 8 - (((lda) << 6)), incAn = -64;
   #define incBk 2
   const int incBm = -64, incBn = (((ldb) << 3));
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 8
   const int incCn = (((ldc) << 3)) - 64;
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(((ldb) << 1)), *pB2=pB1+(((ldb) << 1)), *pB3=pB2+(((ldb) << 1));
   register int k;
   register double rA0, rA1, rA2, rA3;
   register double rB0, rB1, rB2, rB3;
   register double m0, m1, m2, m3;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2, rC0_3, rC1_3, rC2_3, rC3_3;
   do /* N-loop */
   {
      do /* M-loop */
      {
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         rC0_2 = *pC2;
         rC0_3 = *pC3;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         m0 = rA0 * rB0;
         rA3 = pA0[6];
         m1 = rA1 * rB0;
         rB1 = *pB1;
         m2 = rA2 * rB0;
         rB2 = *pB2;
         m3 = rA3 * rB0;
         rB3 = *pB3;

/*
 *       Peel first 1 iterations for C assignment
 */
         rC0_0 = m0;
         m0 = rA0 * rB1;
         rC1_0 = m1;
         m1 = rA1 * rB1;
         rC2_0 = m2;
         m2 = rA2 * rB1;
         rC3_0 = m3;
         m3 = rA3 * rB1;
         rC0_1 = m0;
         m0 = rA0 * rB2;
         rC1_1 = m1;
         m1 = rA1 * rB2;
         rC2_1 = m2;
         m2 = rA2 * rB2;
         rC3_1 = m3;
         m3 = rA3 * rB2;
         rC0_2 = m0;
         m0 = rA0 * rB3;
         rC1_2 = m1;
         m1 = rA1 * rB3;
         rC2_2 = m2;
         m2 = rA2 * rB3;
         rC3_2 = m3;
         m3 = rA3 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[2];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_3 = m0;
         m0 = rA0 * rB0;
         rB1 = pB1[2];
         rC1_3 = m1;
         m1 = rA1 * rB0;
         rB2 = pB2[2];
         rC2_3 = m2;
         m2 = rA2 * rB0;
         rB3 = pB3[2];
         rC3_3 = m3;
         m3 = rA3 * rB0;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=0; k < 30; k++) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB1;
            rC1_0 += m1;
            m1 = rA1 * rB1;
            rC2_0 += m2;
            m2 = rA2 * rB1;
            rC3_0 += m3;
            m3 = rA3 * rB1;
            rC0_1 += m0;
            m0 = rA0 * rB2;
            rC1_1 += m1;
            m1 = rA1 * rB2;
            rC2_1 += m2;
            m2 = rA2 * rB2;
            rC3_1 += m3;
            m3 = rA3 * rB2;
            rC0_2 += m0;
            m0 = rA0 * rB3;
            rC1_2 += m1;
            m1 = rA1 * rB3;
            rC2_2 += m2;
            m2 = rA2 * rB3;
            rC3_2 += m3;
            m3 = rA3 * rB3;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rA1 = pA0[2];
            rA2 = pA0[4];
            rA3 = pA0[6];
            rC0_3 += m0;
            m0 = rA0 * rB0;
            rB1 = pB1[2];
            rC1_3 += m1;
            m1 = rA1 * rB0;
            rB2 = pB2[2];
            rC2_3 += m2;
            m2 = rA2 * rB0;
            rB3 = pB3[2];
            rC3_3 += m3;
            m3 = rA3 * rB0;
            pB0 += incBk;
            pB1 += incBk;
            pB2 += incBk;
            pB3 += incBk;
         } /* end K-loop */
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC1_0 += m1;
         m1 = rA1 * rB1;
         rC2_0 += m2;
         m2 = rA2 * rB1;
         rC3_0 += m3;
         m3 = rA3 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC1_1 += m1;
         m1 = rA1 * rB2;
         rC2_1 += m2;
         m2 = rA2 * rB2;
         rC3_1 += m3;
         m3 = rA3 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rC1_2 += m1;
         m1 = rA1 * rB3;
         rC2_2 += m2;
         m2 = rA2 * rB3;
         rC3_2 += m3;
         m3 = rA3 * rB3;
         pA0 += incAk0;
         rC0_3 += m0;
         rC1_3 += m1;
         rC2_3 += m2;
         rC3_3 += m3;
         pB0 += incBk0;
         pB1 += incBk0;
         pB2 += incBk0;
         pB3 += incBk0;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC1_2 *= rB0;
         rC1_3 *= rB0;
         rC2_0 *= rB0;
         rC2_1 *= rB0;
         rC2_2 *= rB0;
         rC2_3 *= rB0;
         rC3_0 *= rB0;
         rC3_1 *= rB0;
         rC3_2 *= rB0;
         rC3_3 *= rB0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         *pC1 = rC0_1;
         pC1[2] = rC1_1;
         pC1[4] = rC2_1;
         pC1[6] = rC3_1;
         *pC2 = rC0_2;
         pC2[2] = rC1_2;
         pC2[4] = rC2_2;
         pC2[6] = rC3_2;
         *pC3 = rC0_3;
         pC3[2] = rC1_3;
         pC3[4] = rC2_3;
         pC3[6] = rC3_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
